signature InstCacheBlocking where {
import Assert;
		
import Counter;
		 
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import Inout;
	       
import List;
	      
import BFIFO;
	    
import Clocks;
		
import ListN;
	       
import PrimArray;
		   
import RWire;
	       
import RegFile;
		 
import Vector;
		
import Connectable;
		     
import GetPut;
		
import ClientServer;
		      
import Trace;
	    
import MemTypes;
	       
import ProcTypes;
		
interface (InstCacheBlocking.ICacheStats :: *) = {
    InstCacheBlocking.num_accesses :: GetPut.Get ProcTypes.Stat;
    InstCacheBlocking.num_misses :: GetPut.Get ProcTypes.Stat;
    InstCacheBlocking.num_evictions :: GetPut.Get ProcTypes.Stat
};
 
instance InstCacheBlocking Prelude.PrimMakeUndefined InstCacheBlocking.ICacheStats;
											
instance InstCacheBlocking Prelude.PrimDeepSeqCond InstCacheBlocking.ICacheStats;
										      
instance InstCacheBlocking Prelude.PrimMakeUninitialized InstCacheBlocking.ICacheStats;
											    
interface (InstCacheBlocking.ICache :: * -> * -> *) req_t resp_t = {
    InstCacheBlocking.proc_server :: ClientServer.Server req_t resp_t;
    InstCacheBlocking.mmem_client :: ClientServer.Client MemTypes.MainMemReq MemTypes.MainMemResp;
    InstCacheBlocking.statsEn_put :: GetPut.Put Prelude.Bool;
    InstCacheBlocking.stats :: InstCacheBlocking.ICacheStats
};
 
instance InstCacheBlocking (Prelude.PrimMakeUndefined resp_t) =>
			   Prelude.PrimMakeUndefined (InstCacheBlocking.ICache req_t resp_t);
												  
instance InstCacheBlocking (Prelude.PrimDeepSeqCond resp_t) =>
			   Prelude.PrimDeepSeqCond (InstCacheBlocking.ICache req_t resp_t);
												
instance InstCacheBlocking Prelude.PrimMakeUninitialized
			   (InstCacheBlocking.ICache req_t resp_t);
								  
type (InstCacheBlocking.CacheLineIndexSz :: #) = 10;
						   
type (InstCacheBlocking.CacheLineTagSz :: #) = 20;
						 
type (InstCacheBlocking.CacheLineSz :: #) = 32;
					      
type (InstCacheBlocking.CacheLineIndex :: *) = Prelude.Bit InstCacheBlocking.CacheLineIndexSz;
												   
type (InstCacheBlocking.CacheLineTag :: *) = Prelude.Bit InstCacheBlocking.CacheLineTagSz;
											       
type (InstCacheBlocking.CacheLine :: *) = Prelude.Bit InstCacheBlocking.CacheLineSz;
											 
data (InstCacheBlocking.CacheStage :: *) =
    InstCacheBlocking.Init () |
    InstCacheBlocking.Access () |
    InstCacheBlocking.Evict () |
    InstCacheBlocking.RefillReq () |
    InstCacheBlocking.RefillResp ();
				   
instance InstCacheBlocking Prelude.PrimMakeUndefined InstCacheBlocking.CacheStage;
										       
instance InstCacheBlocking Prelude.PrimDeepSeqCond InstCacheBlocking.CacheStage;
										     
instance InstCacheBlocking Prelude.PrimMakeUninitialized InstCacheBlocking.CacheStage;
											   
instance InstCacheBlocking Prelude.Eq InstCacheBlocking.CacheStage;
									
instance InstCacheBlocking Prelude.Bits InstCacheBlocking.CacheStage 3;
									    
InstCacheBlocking.getAddr :: MemTypes.InstReq -> Prelude.Bit MemTypes.AddrSz;
										  
InstCacheBlocking.getCacheLineIndex :: MemTypes.InstReq -> InstCacheBlocking.CacheLineIndex;
											   
InstCacheBlocking.getCacheLineTag :: MemTypes.InstReq -> InstCacheBlocking.CacheLineTag;
										       
InstCacheBlocking.getCacheLineAddr :: MemTypes.InstReq -> Prelude.Bit MemTypes.AddrSz;
											   
InstCacheBlocking.mkInstCache :: (Prelude.IsModule _m__ _c__) =>
				 _m__ (InstCacheBlocking.ICache MemTypes.InstReq MemTypes.InstResp)
}
